REM Copyright  December 2003, James Aswell
REM
REM INFO: PixelResize.csc v1.02 (PPX4)
REM 
REM DESCRIPTION:
REM This script makes it simple to resize an object to a
REM specific size in pixels. I recommend running this from
REM the Tools/Run Corel Script menu item.
REM
REM NOTES:
REM This may be a little buggy, but you got what you paid
REM for.  :)  If you click back and forth between the
REM width and height boxes, they may change on their own.
REM There may be other issues as well.  If you find
REM any bugs, have suggestions for features, etc.,
REM please submit a report at the following URL:
REM
REM http://www.antipoetics.com/contact/support.shtml


Declare Sub EnableControl(ByVal Unlock as Boolean)

Global lastObject&
Global scaleFactor&
Global objWidth&, objHeight&
Global xLeft&, xTop&, xRight&, xBottom&
Global newWidth&, newHeight&
Global sname$
sname$ = "PixelResize"

On Error Goto ErrorHandler

WITHOBJECT "CorelPhotoPaint.Automation.14"

BEGIN DIALOG OBJECT Dialog1 341, 21, sname$, SUB GoDialog
	SPINCONTROL  32, 3, 39, 14, .Spin1
	SPINCONTROL  109, 3, 39, 14, .Spin2
	PUSHBUTTON  261, 3, 35, 14, .Button1, "Apply"
	PUSHBUTTON  302, 3, 35, 14, .Button2, "Reset"
	CHECKBOX  212, 4, 45, 11, .Check1, "Anti-Alias"
	CHECKBOX  155, 4, 53, 11, .Check2, "Proportional"
	TEXT  4, 5, 28, 11, .Text1, "Width:"
	TEXT  81, 5, 28, 11, .Text2, "Height:"
END DIALOG

Dialog1.Spin1.SetMinRange 1
Dialog1.Spin2.SetMinRange 1
Dialog1.Check1.SetThreeState False
Dialog1.Check2.SetThreeState False
Dialog1.Check1.SetValue 1
Dialog1.Check2.SetValue 1

lastObject& = 0
scaleFactor& = 1

Dialog Dialog1

Goto Finish

Sub GoDialog(BYVAL ControlID%, BYVAL Event%)
	'Dialog1.SetText "ID: " & ControlID & ", Event: " & Event%

	'check to see if selected object has changed
	If .GetDocumentCount() = 0 Then
		ObjCount& = 0
	Else
		.BindToActiveDocument
		ObjCount& = .GetObjectCount()
	EndIF

	If ObjCount& = 0 Then
		EnableControl False
	Else
		EnableControl True

		ObjSelect& = 0
		For i& = 1 TO ObjCount&
			If .GetObjectIsSelected(i&) <> 0 THEN 
				ObjSelect& = i&
				'get the object rectangle
				If ObjSelect& <> lastObject& Then
					Event% = 0
					lastObject& = ObjSelect&
				EndIf
	
				.GetObjectRectangle lastObject&, xLeft&, xTop&, xRight&, xBottom&
				objWidth& = (xRight& - xLeft&) + 1
				objHeight& = (xBottom& - xTop&) + 1
	
				Dialog1.SetText sname$ & " - object: " & ObjSelect& & " - dimensions: " & objWidth& & " x " & objHeight&

				If Event = 0 OR (Dialog1.Check2.GetValue() = 1 And ControlID = 6) Then
					Dialog1.Spin1.SetValue objWidth&
					Dialog1.Spin2.SetValue objHeight&
				EndIf
				Exit For
			EndIf
		Next i

		If ObjSelect& = 0 Then
			EnableControl False
		Else
			EnableControl True
		EndIf

	EndIf

	If ObjSelect& = 0 Then Dialog1.SetText sname$ & " - no objects selected"

	If Event% = 0 Then

	ElseIf Event% <> 4 Then
		If ControlID% = 1 Then 'width changed
			If Dialog1.Check2.GetValue() = 1 Then
				Dialog1.Spin2.SetValue (objHeight& / objWidth&) * Dialog1.Spin1.GetValue()
			EndIf
		ElseIf ControlID% = 2 Then 'height changed
			If Dialog1.Check2.GetValue() = 1 Then
				Dialog1.Spin1.SetValue (objWidth& / objHeight&) * Dialog1.Spin2.GetValue()
			EndIf
		ElseIf ControlID% = 3 Then 'apply was pressed
			'apply the resize to the selected object

			newWidth& = Dialog1.Spin1.GetValue() - 1
			newHeight& = Dialog1.Spin2.GetValue() - 1

			.ObjectDistort xLeft&, xTop&, xLeft& + newWidth&, xTop&, xLeft& + newWidth&, xTop& + newHeight&, xLeft&, xTop& + newHeight&, -(Dialog1.Check1.GetValue())
				.EndObject 

		ElseIf ControlID% = 4 Then 'reset was pressed
				'restore width and height values
			Dialog1.Spin1.SetValue objWidth&
			Dialog1.Spin2.SetValue objHeight&
		EndIf
	EndIf

End Sub

Sub EnableControl(ByVal Unlock As Boolean)
	Dialog1.Spin1.Enable Unlock
	Dialog1.Spin2.Enable Unlock
	Dialog1.Check1.Enable Unlock
	Dialog1.Check2.Enable Unlock
	Dialog1.Button1.Enable Unlock
End Sub

Finish:

END WITHOBJECT

End

ErrorHandler:
SELECT CASE ERRNUM
	CASE 611
		MESSAGE "Photo-Paint X4 is not currently running."
		Goto Finish
	CASE ELSE
		MESSAGE "Unexpected error"
END SELECT
